----------------------------------------------
--
-- "DM Offensive" Script by DreyLiky		--
-- 
-- version 1.2								--
--
-- Enjoy and have fun! If you have some idea for this script, write me on Email: DreyLiky@gmail.com
--
----------------------------------------------

addhook("spawn", "spawnController");
addhook("buy", "buyController");
addhook("say", "commandsController");
addhook("menu", "menuController");
addhook("join", "joinController");
addhook("team", "teamController");
addhook("drop", "antiDropController");
addhook("walkover", "antiCollectController");
addhook("kill", "killController");
addhook("minute", "bonusController");

respFromBonus = true;															-- Should player respawning, when he selected some kind of "Bonus Weapon"?  Yes - true, No - false

botWeapons = {																	-- List of Ids of weapons, from which bots can equip one weapon
	["t"]  = { 30, 38, 37, 23, 20, 22, 24, 34, 35 },
	["ct"] = { 32, 39, 33, 21, 20, 22, 24, 34, 35 }
};

bonusWeapon = { 
	["weaponsId"]    = { 1, 3, 6, 10, 11, 20, 24, 30, 32, 36, 40, 90, 91 },		-- Main list of Ids of weapons, from which showing random "Bonus Weapon"
	["randNums"]     = {},
	["nowWeapon"]    = nil,
	["tipObj"]       = nil,
	["status"]       = false,
	["trigger"]      = true,
	["playersData"]  = {}
};

playersData = {};																-- Here script save information about all players. Do not delete if you want the script to work correctly

-- Applying the necessary settings to the server
parse('sv_gamemode 2');
parse('mp_hud 79');
parse('mp_infammo 1');
parse('mp_deathdrop 4');
parse('mp_randomspawn 1');


function spawnController(id, isBonus)
	
	parse('drawradar 0');
	
	local eff;
	local effParams;
	
	if (isBonus) then
		function randomRespawn()
			 local tryPos = {}
			 
			 repeat tryPos.x, tryPos.y = math.random(0, map("xsize")), math.random(0, map("ysize"))
			 until (tile(tryPos.x, tryPos.y, "walkable") and tile(tryPos.x, tryPos.y, "frame") > 0)
			 parse('setpos '..id..' '..(tryPos.x * 32 + 16)..' '..(tryPos.y * 32 + 16));
		end
		
		if (respFromBonus) then																			--    ,   
			randomRespawn();
			eff = "flare";
			effParams = "64 64 0 255 0";
			parse('sethealth '..id..' 100');
			parse('setarmor '..id..' 100');
		else
			eff = "flare";
			effParams = "32 32 60 180 170";
		end
		
	else
		eff = "fire";
		effParams = "32 32 255 220 0";
	end
	
	
	timer(50, "spawnSettings");
	function spawnSettings()
		if (respFromBonus) then
			parse('sv_soundpos "env/csgo_dm/dm_respawn.ogg" '..player(id, "x")..' '..player(id, "y"));	--   
		end
		parse('effect "'..eff..'" '..player(id, "x")..' '..player(id, "y")..' '..effParams);
	end
	
	if (not player(id, "bot")) then 																	--    
		if (playersData[caseForData(id)].weapons.rifle ~= nil) then										--   
			local listToGet = "";
			if (playersData[caseForData(id)].weapons.pistol ~= nil) then listToGet = listToGet..playersData[caseForData(id)].weapons.pistol end
			listToGet = listToGet..', '..playersData[caseForData(id)].weapons.rifle;
			
			return listToGet..', 58';
		else																							--     
			parse('setarmor '..id..' 100');
			timer(200, "buyMenu", "{ playerId = "..id..", page = 1 }");
		end
	else																								--    -    
		applyWeapon(id, nil, 99);
		parse('setarmor '..id..' 100');
	end
end



function buyMenu(data)
	dataParams = loadstring("return "..data)();
	
	if (dataParams.page == 1) then
		if (player(dataParams.playerId, "team") == 2) then
			menu(dataParams.playerId, "Buy rifle,M4A1,Famas,Aug,TMP,MP5,P90,UMP45,Scout,AWP");
		else
			menu(dataParams.playerId, "Buy rifle,AK-47,Galil,SG550,MAC10,MP5,P90,UMP45,Scout,AWP");
		end
	elseif (dataParams.page == 2) then
		menu(dataParams.playerId, "Buy pistol,USP,Glock,Deagle,P228,Elite,Five-Seven");
	end
end


function menuController(id, title, button)

	if (title == 'Buy rifle') then
		
		if (player(id, "team") == 2) then							--   CT
			if (button == 1) then applyWeapon(id, 32, 1);
				elseif (button == 2) then applyWeapon(id, 39, 1);
				elseif (button == 3) then applyWeapon(id, 33, 1);
				elseif (button == 4) then applyWeapon(id, 21, 1);
				elseif (button == 5) then applyWeapon(id, 20, 1);
				elseif (button == 6) then applyWeapon(id, 22, 1);
				elseif (button == 7) then applyWeapon(id, 24, 1);
				elseif (button == 8) then applyWeapon(id, 34, 1);
				elseif (button == 9) then applyWeapon(id, 35, 1);
				else buyMenu("{ playerId = "..id..", page = 2 }");
			end
		else														--   T
			if (button == 1) then applyWeapon(id, 30, 1);
				elseif (button == 2) then applyWeapon(id, 38, 1);
				elseif (button == 3) then applyWeapon(id, 37, 1);
				elseif (button == 4) then applyWeapon(id, 23, 1);
				elseif (button == 5) then applyWeapon(id, 20, 1);
				elseif (button == 6) then applyWeapon(id, 22, 1);
				elseif (button == 7) then applyWeapon(id, 24, 1);
				elseif (button == 8) then applyWeapon(id, 34, 1);
				elseif (button == 9) then applyWeapon(id, 35, 1);
				else buyMenu("{ playerId = "..id..", page = 2 }");
			end
		end
		
	elseif (title == 'Buy pistol') then
		
		if (button == 1) then applyWeapon(id, 1, 2);
			elseif (button == 2) then applyWeapon(id, 2, 2);
			elseif (button == 3) then applyWeapon(id, 3, 2);
			elseif (button == 4) then applyWeapon(id, 4, 2);
			elseif (button == 5) then applyWeapon(id, 5, 2);
			elseif (button == 6) then applyWeapon(id, 6, 2);
		end
		
	end
end


function applyWeapon(playerId, weapId, page, isAutoBuy)
	local itemlist = playerweapons(playerId);
	
	if (page == 1) then
		if (weapId > 6 and weapId < 50 or weapId == 91 or weapId == 90 or weapId == 88) then
			for i, itemId in pairs(itemlist) do
				if (itemId > 6 and itemId ~= 50) then parse('strip '..playerId..' '..itemId); end
			end
		end
		
		if (not isAutoBuy) then
			buyMenu("{ playerId = "..playerId..", page = 2 }");
		end
		
		if (bonusWeapon.nowWeapon ~= weapId) then
			playersData[caseForData(playerId)].weapons.rifle = weapId;
		else
			if (bonusWeapon.playersData[caseForData(playerId)]) then
				playersData[caseForData(playerId)].weapons.rifle = weapId;
			end
		end
		
	elseif (page == 2) then
		for i, itemId in pairs(itemlist) do
			if (itemId < 7) then parse('strip '..playerId..' '..itemId); end
		end
		
		if (bonusWeapon.nowWeapon ~= weapId) then playersData[caseForData(playerId)].weapons.pistol = weapId; end
		
	elseif (page == 99) then 																						--      (   botWeapons)
		local num;
		if (player(playerId, "team") == 2) then
			num = math.random(1, table.getn(botWeapons["ct"]));
			parse('equip '..playerId..' '..botWeapons.ct[num]);
		elseif (player(playerId, "team") == 1) then
			num = math.random(1, table.getn(botWeapons["t"]));
			parse('equip '..playerId..' '..botWeapons.t[num]);
		end
		
		return;
	end
	
	parse('equip '..playerId..' '..weapId);
	parse('setweapon '..playerId..' '..weapId);
end


function killController(killer, victim, weap, x, y, obj)
	
	function killEffect(speed, color)
		local sprite = image("gfx/block.bmp", 0, 0, 2, killer);
		imagealpha(sprite, 0.2);
		imagecolor(sprite, color[1], color[2], color[3]);
		imagescale(sprite, player(killer, "screenw"), player(killer, "screenh"));
		tween_alpha(sprite, speed, 0);
		timer(speed, "delSprite")
		
		function delSprite()
			parse('killobject '..sprite);
		end
	end
	
	if (playersData[caseForData(killer)].kills[caseForData(victim)] == nil) then					--       , ,    
		playersData[caseForData(killer)].kills[caseForData(victim)] = {};
	end
	
	if (playersData[caseForData(victim)].kills[caseForData(killer)] == nil) then					--       , ,    
		playersData[caseForData(victim)].kills[caseForData(killer)] = {};
	end
	
	local numOfKillerKills = playersData[caseForData(killer)].kills[caseForData(victim)].count;		--    , 
	local numOfVictimKills = playersData[caseForData(victim)].kills[caseForData(killer)].count;		--    , 
	
	
	if (numOfKillerKills == nil) then																--      ,   -  = 0
		playersData[caseForData(killer)].kills[caseForData(victim)].count = 0;
		numOfKillerKills = 0;
	end
	
	playersData[caseForData(killer)].kills[caseForData(victim)].count = numOfKillerKills + 1;		--      1
	
	local killSound;
	if (bonusWeapon.status) then
		if (bonusWeapon.nowWeapon == weap) then
			killSound = "env/csgo_dm/dm_kill_bonus.ogg";											--   
		else
			killSound = "env/csgo_dm/dm_kill.ogg";
		end
	else
		killSound = "env/csgo_dm/dm_kill.ogg";
	end
	
	parse('sv_sound2 '..killer..' '..killSound);													--    
	
	if (numOfVictimKills ~= nil) then
		if (numOfVictimKills >= 3) then																--     
			msg2(killer, '255000000'..player(victim, "name")..' 000255000now does not dominate you');
			msg2(victim, 'You no longer dominate 255000000'..player(killer, "name")..'@C');
			parse('sv_sound2 '..killer..' "env/csgo_dm/dm_domination.ogg"');						--    
		end
		
		playersData[caseForData(victim)].kills[caseForData(killer)].count = 0;						--     = 0
	end
	
	if (numOfKillerKills == 0) then																	--    ,  = 0, ...
		
		killEffect(500, {0, 255, 0});
		parse('sv_sound2 '..victim..' "env/csgo_dm/dm_deathcam_gg_01.ogg"');						--    
		
	elseif (numOfKillerKills == 1) then																--    ,  = 1, ...
		
		killEffect(500, {255, 220, 0});
		parse('sv_sound2 '..victim..' "env/csgo_dm/dm_deathcam_gg_02.ogg"');						--    
		
	elseif (numOfKillerKills == 2) then																--    ,  = 2, ...
		
		killEffect(500, {255, 120, 0});
		parse('sv_sound2 '..victim..' "env/csgo_dm/dm_deathcam_gg_03.ogg"');						--    
		
	elseif (numOfKillerKills >= 3) then																--    ,  >= 3,     
		
		if (numOfKillerKills == 3) then 
			killEffect(500, {120, 0, 255});
			msg2(killer, "You are now dominating 255000000"..player(victim, "name"));
			msg2(victim, "255000000"..player(killer, "name").."255220000 now dominating you@C");
		else
			killEffect(500, {255, 0, 0});
			msg2(killer, "You are still dominating 255000000"..player(victim, "name"));
			msg2(victim, "255000000"..player(killer, "name").."255220000 still dominating you@C");
		end
		
		parse('sv_sound2 '..killer..' "env/csgo_dm/dm_domination.ogg"');							--    
		parse('sv_sound2 '..victim..' "env/csgo_dm/dm_nemesis.ogg"');								--    
		
	end
	
end


function commandsController(id, mesg)
	if (mesg == 'guns') then
		buyMenu("{ playerId = "..id..", page = 1 }");
	end
end


function bonusController()
	if (bonusWeapon.trigger) then
		bonusAlert(300);
		bonusWeapon.trigger = false;
	else
		msg('Press "000255000G255220000" or write "000255000guns255220000" in chat to select weapon');
		bonusWeapon.trigger = true;
	end
end


function bonusAlert(speed)
	if (bonusWeapon.status) then return end	 																--   bonusAlert,     
	
	bonusWeapon.status = true;																				--    
	
	local numOfIds = table.getn(bonusWeapon.weaponsId);														--     ID  
	local numId = 1;
	
	while true do
		if (numOfIds ~= 0) then
			numId = math.random(1, numOfIds);																--   ,     ID  
			local different = { table.getn(bonusWeapon.randNums), table.getn(bonusWeapon.weaponsId) };
			
			if (different[1] == different[2]) then															--        
				bonusWeapon.randNums = {};
				numId = math.random(1, numOfIds);
				bonusWeapon.randNums[1] = numId;
				break
			else																							--        
				local ok = 0;
				for i = 1, different[1] do
					if (numId == bonusWeapon.randNums[i]) then ok = ok + 1; end								--    ,     
				end
				
				if (ok == 0) then																			--   ,            
					bonusWeapon.randNums[different[1] + 1] = numId;
					break
				end
			end
			
			
		else
			msg("255000000ADMIN!!! WRITE ID's OF WEAPONS IN \"DM OFFENSIVE\" SCRIPT!!! HERE IS BUG!!!@C");
			bonusWeapon.weaponsId = { 10 };
			break
		end
	end
	
	bonusWeapon.nowWeapon = bonusWeapon.weaponsId[numId];													--    
	local weaponSubName = string.gsub(itemtype(bonusWeapon.weaponsId[numId], "name"), "%s+ -", "");			--     
	weaponSubName = string.gsub(weaponSubName, "-", "");													--     
	
	parse('sv_sound "env/csgo_dm/dm_bonus_alert_start.ogg"');
	
	local bonusBg = image("gfx/sprites/csgo_dm/bonusBG.png", 0, 200, 2);
	imagealpha(bonusBg, 0);
	tween_move(bonusBg, speed, 112, 200);
	tween_alpha(bonusBg, speed, 0.7);
	
	local bonusTip = image("gfx/sprites/csgo_dm/bonusTip.png", 0, 200, 2);
	imagealpha(bonusTip, 0);
	tween_move(bonusTip, speed, 112, 200);
	tween_alpha(bonusTip, speed, 0.7);
	bonusWeapon.tipObj = bonusTip;
	
	local bWeapon = image("gfx/weapons/"..weaponSubName.."_k.bmp", 85, 176, 2, 0);
	imagecolor(bWeapon, 0, 0, 0);
	imagealpha(bWeapon, 0);
	tween_move(bWeapon, speed, 209, 176);
	tween_alpha(bWeapon, speed, 0.6);
	
	local bonusTimeline = image("gfx/sprites/csgo_dm/bonusTimeline.png", 0, 187, 2);
	imagealpha(bonusTimeline, 0);
	tween_move(bonusTimeline, speed, 95, 187);
	tween_alpha(bonusTimeline, speed, 1.0);
	
	--    timeline
	timer(speed, "timelineStart");
	function timelineStart()
		tween_scale(bonusTimeline, 30000, 0, 1);
		tween_move(bonusTimeline, 30000, 175, 187);
	end
	
	local weapName = itemtype(bonusWeapon.weaponsId[numId], "name");
	if (string.len(weapName) > 10) then
		weapName = string.sub(weapName, 0, 10)..'...';
	end
	
	parse('hudtxt b_title "040040040Bonus weapon: 000000000'..weapName..'" -80 165 0');
	parse('hudtxtmove 0 b_title '..speed..' 6 165');
	
	timer(speed + 30000, "endBonusAlert");
	timer(speed + 5000, "closeTip");
	
	function closeTip()
		tween_move(bonusTip, 300, 0, 200);
		tween_alpha(bonusTip, 300, 0);
	end
	
	function endBonusAlert()
		parse('sv_sound "env/csgo_dm/dm_bonus_alert_end.ogg"');
		tween_move(bonusBg, speed, 0, 200);
		tween_alpha(bonusBg, speed, 0);
		
		tween_move(bWeapon, speed, 85, 176);
		tween_alpha(bWeapon, speed, 0);
		
		tween_move(bonusTimeline, speed, 0, 187);
		tween_alpha(bonusTimeline, speed, 0);
		
		parse('hudtxtmove 0 b_title '..speed..' -80 165');
		parse('hudtxtalphafade 0 b_title '..speed..' 0');
		
		timer(speed, "delete");
		function delete()
			bonusWeapon.playersData = {};																	--    ( ,      )
			bonusWeapon.status      = false;
			bonusWeapon.nowWeapon   = nil;
			
			parse('killobject '..bonusBg);
			parse('killobject '..bonusTip);
			parse('killobject '..bWeapon);
			parse('killobject '..bonusTimeline);
			parse('hudtxt b_title');
		end
		
	end
end


function joinController(id)
	if (bonusWeapon.status) then
	
	end

	-- C       playersData
	playersData[caseForData(id)] = {};
	playersData[caseForData(id)].kills = {};
	playersData[caseForData(id)].weapons = {};
	playersData[caseForData(id)].weapons.rifle = nil;
	playersData[caseForData(id)].weapons.pistol = nil;
end


function teamController(id)
	--    
	playersData[caseForData(id)] = {};
	playersData[caseForData(id)].kills = {};
	playersData[caseForData(id)].weapons = {};
	playersData[caseForData(id)].weapons.rifle = nil;
	playersData[caseForData(id)].weapons.pistol = nil;
end


function antiDropController(playerId)
	if (bonusWeapon.status) then														--     
		if (bonusWeapon.playersData[caseForData(playerId)] ~= true) then				--        
			
			local numOfpage;
			if (bonusWeapon.nowWeapon < 7) then numOfpage = 2;
			else numOfpage = 1; end

			applyWeapon(playerId, bonusWeapon.nowWeapon, numOfpage, true);				--   
			spawnController(playerId, true);
			bonusWeapon.playersData[caseForData(playerId)] = true;						--         
		else
			buyMenu('{ playerId='..playerId..', page=1 }');
		end
	else
		buyMenu('{ playerId='..playerId..', page=1 }');
	end
	return 1;
end


function antiCollectController()
	return 1;
end


function buyController()
	return 1;
end


function caseForData(playerId)
	--          playersData.
	--    ,    playersData   ,
	--     ,      IP
	
	if (player(playerId, "bot")) then return player(playerId, "name");
		else return player(playerId, "ip");
	end
end